<template>
<st-content heading="Mis citas">
<div>
  <div class="content-body">
    <v-row>
      <st-search
        text="Buscar por nombre de tutoría"
        @enter="search($event)"
      />
     <v-col md="4">
        <st-select
          nombre = "Estado de la sesión de tutoría"
          :items = "estados"
          itemText = "nombre"
          itemValue = "nombre"
          @cambioNombre="cambioPadre"
          :value = "estado"
        />
      </v-col>
    </v-row>
     <v-data-table
    v-bind="{ headers,items }"
    :hide-default-footer="items.length <= 10"
    :loading="loading"
    loading-text="Cargando..."
    no-data-text="No se encontraron resultados"
    :sort-by="['fecha']"
    :sort-desc="[true]"
    :search="estado"
    :items-per-page="itemsPerPage"
  >
  <template
            v-slot:item.fecha="{ item }" >
    {{ item.fecha | formatDate }}
  </template>
     </v-data-table>
  </div>
</div>
</st-content>
</template>

<script>
import DataTable from '@/components/DataTable'
import Select from '@/components/Select'
import DatePicker from '@/components/DatePicker'
import Search from '@/components/Search'
export default {
  data () {
    return{
      itemsPerPage : 10,
      estado: 'Pendiente',
      items: [],
      estados: [],
      loading:false,
      headers: [
        {
          text: 'Nombre de la tutoría',
          align: 'start',
          sortable: false,
          value: 'nombre',
        },
        {
          text: 'Tutor',
          sortable: false,
          value: 'tutor'
        },
        {
          text: 'Fecha y Hora de Inicio',
          value: 'fecha'
        },{
          text: 'Estado',
          value: 'estado'
        },
      ],
      filters:{
        search:'',
        estadoTut:'',
      }
    }
  },
  components: {
    'st-data-table' : DataTable,
    'st-select' : Select,
    'st-date-picker': DatePicker,
    'st-search': Search,
  },
  filters: {
    formatDate: function(value){
      if(!value) return "Cargando...";
      let options = { year: 'numeric', month: 'long', day: 'numeric', hour12: 'true',timeStyle: 'short', dateStyle: 'long'}
      let d = new Date(value).toLocaleTimeString('es', options)
      return d
    }
  },
  mounted(){
    this.search('')
  },
  methods: {
    cambioPadre(dato){
      this.filters.estadoTut = dato;
      if(dato == "Todos") this.estado = "";
      else this.estado = dato;
    },
    async search(value){
      this.loading = true
      try {
        this.estados.push({nombre: 'Todos'})
        let { data: { data } } = await this.$api.getAppointments(this.$store.state.role.id)
        let { data: {data: {estados}} } = await this.$api.getStatus()
        this.items = data
        for (let it in estados){
          this.estados.push(estados[it])
        }
      } catch (error) {
        this.$store.commit('setError', error)
      }
      this.loading = false
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
